import "reflect-metadata"; // Required for TypeORM
import { DataSource } from "typeorm";
import * as config from "~/config.js";

// Entity types
import { PollCategory, PollRole } from "~entities/category.js";
import { Poll, PollOption, Vote } from "~entities/poll.js";

const VoterDataSource = new DataSource({
  type: "better-sqlite3",
  database: config.DATABASE,
  entities: [PollCategory, PollRole, Poll, PollOption, Vote],
  migrations: ["src/db/migrations/*.js"],
  logging:
    process.env.NODE_ENV === "production" ? ["error"] : ["query", "error"],
});

export default VoterDataSource;
