export class Init1690840507258 {
  name = "Init1690840507258";

  async up(queryRunner) {
    await queryRunner.query(`
            CREATE TABLE "poll" (
                "id" integer PRIMARY KEY AUTOINCREMENT NOT NULL,
                "guildId" bigint NOT NULL,
                "name" text NOT NULL,
                "channelId" bigint NOT NULL,
                "messageId" bigint,
                "categoryId" integer
            )
        `);
    await queryRunner.query(`
            CREATE UNIQUE INDEX "IDX_80709744068ae7f7a3ddd9b689" ON "poll" ("messageId")
        `);
    await queryRunner.query(`
            CREATE INDEX "IDX_8649558b66d5659d710b2a441b" ON "poll" ("guildId", "id")
        `);
    await queryRunner.query(`
            CREATE TABLE "poll_option" (
                "id" integer PRIMARY KEY AUTOINCREMENT NOT NULL,
                "name" text NOT NULL,
                "pollId" integer
            )
        `);
    await queryRunner.query(`
            CREATE TABLE "vote" (
                "optionId" integer NOT NULL,
                "userId" bigint NOT NULL,
                "pollId" integer,
                PRIMARY KEY ("optionId", "userId")
            )
        `);
    await queryRunner.query(`
            CREATE TABLE "poll_category" (
                "id" integer PRIMARY KEY AUTOINCREMENT NOT NULL,
                "guildId" bigint NOT NULL,
                "name" text NOT NULL,
                "channelId" bigint NOT NULL
            )
        `);
    await queryRunner.query(`
            CREATE UNIQUE INDEX "IDX_dd5d702fa30a021365cf68d938" ON "poll_category" ("guildId", "name")
        `);
    await queryRunner.query(`
            CREATE TABLE "poll_role" (
                "id" integer PRIMARY KEY AUTOINCREMENT NOT NULL,
                "roleId" text NOT NULL,
                "type" text NOT NULL,
                "categoryId" integer,
                "pollId" integer
            )
        `);
    await queryRunner.query(`
            CREATE UNIQUE INDEX "IDX_d62df873efb4582f4aa48dbe12" ON "poll_role" ("pollId", "roleId")
        `);
    await queryRunner.query(`
            CREATE UNIQUE INDEX "IDX_7f9f6fe949ee5383fb130c60a5" ON "poll_role" ("categoryId", "roleId")
        `);
    await queryRunner.query(`
            DROP INDEX "IDX_80709744068ae7f7a3ddd9b689"
        `);
    await queryRunner.query(`
            DROP INDEX "IDX_8649558b66d5659d710b2a441b"
        `);
    await queryRunner.query(`
            CREATE TABLE "temporary_poll" (
                "id" integer PRIMARY KEY AUTOINCREMENT NOT NULL,
                "guildId" bigint NOT NULL,
                "name" text NOT NULL,
                "channelId" bigint NOT NULL,
                "messageId" bigint,
                "categoryId" integer,
                CONSTRAINT "FK_c395eb62e17476f4fe254ab54b6" FOREIGN KEY ("categoryId") REFERENCES "poll_category" ("id") ON DELETE NO ACTION ON UPDATE NO ACTION
            )
        `);
    await queryRunner.query(`
            INSERT INTO "temporary_poll"(
                    "id",
                    "guildId",
                    "name",
                    "channelId",
                    "messageId",
                    "categoryId"
                )
            SELECT "id",
                "guildId",
                "name",
                "channelId",
                "messageId",
                "categoryId"
            FROM "poll"
        `);
    await queryRunner.query(`
            DROP TABLE "poll"
        `);
    await queryRunner.query(`
            ALTER TABLE "temporary_poll"
                RENAME TO "poll"
        `);
    await queryRunner.query(`
            CREATE UNIQUE INDEX "IDX_80709744068ae7f7a3ddd9b689" ON "poll" ("messageId")
        `);
    await queryRunner.query(`
            CREATE INDEX "IDX_8649558b66d5659d710b2a441b" ON "poll" ("guildId", "id")
        `);
    await queryRunner.query(`
            CREATE TABLE "temporary_poll_option" (
                "id" integer PRIMARY KEY AUTOINCREMENT NOT NULL,
                "name" text NOT NULL,
                "pollId" integer,
                CONSTRAINT "FK_a1200fcfcdab6145351545f26ea" FOREIGN KEY ("pollId") REFERENCES "poll" ("id") ON DELETE NO ACTION ON UPDATE NO ACTION
            )
        `);
    await queryRunner.query(`
            INSERT INTO "temporary_poll_option"("id", "name", "pollId")
            SELECT "id",
                "name",
                "pollId"
            FROM "poll_option"
        `);
    await queryRunner.query(`
            DROP TABLE "poll_option"
        `);
    await queryRunner.query(`
            ALTER TABLE "temporary_poll_option"
                RENAME TO "poll_option"
        `);
    await queryRunner.query(`
            CREATE TABLE "temporary_vote" (
                "optionId" integer NOT NULL,
                "userId" bigint NOT NULL,
                "pollId" integer,
                CONSTRAINT "FK_4ae2eb8e398ff87416da92ea286" FOREIGN KEY ("optionId") REFERENCES "poll_option" ("id") ON DELETE NO ACTION ON UPDATE NO ACTION,
                CONSTRAINT "FK_3827d62f3c37dc8a63a13c4d0da" FOREIGN KEY ("pollId") REFERENCES "poll" ("id") ON DELETE NO ACTION ON UPDATE NO ACTION,
                PRIMARY KEY ("optionId", "userId")
            )
        `);
    await queryRunner.query(`
            INSERT INTO "temporary_vote"("optionId", "userId", "pollId")
            SELECT "optionId",
                "userId",
                "pollId"
            FROM "vote"
        `);
    await queryRunner.query(`
            DROP TABLE "vote"
        `);
    await queryRunner.query(`
            ALTER TABLE "temporary_vote"
                RENAME TO "vote"
        `);
    await queryRunner.query(`
            DROP INDEX "IDX_d62df873efb4582f4aa48dbe12"
        `);
    await queryRunner.query(`
            DROP INDEX "IDX_7f9f6fe949ee5383fb130c60a5"
        `);
    await queryRunner.query(`
            CREATE TABLE "temporary_poll_role" (
                "id" integer PRIMARY KEY AUTOINCREMENT NOT NULL,
                "roleId" text NOT NULL,
                "type" text NOT NULL,
                "categoryId" integer,
                "pollId" integer,
                CONSTRAINT "FK_fbc0f58dc875ec3aa7cad72511c" FOREIGN KEY ("categoryId") REFERENCES "poll_category" ("id") ON DELETE NO ACTION ON UPDATE NO ACTION,
                CONSTRAINT "FK_75a0c4fbd9adf8506766bc2aead" FOREIGN KEY ("pollId") REFERENCES "poll" ("id") ON DELETE NO ACTION ON UPDATE NO ACTION
            )
        `);
    await queryRunner.query(`
            INSERT INTO "temporary_poll_role"("id", "roleId", "type", "categoryId", "pollId")
            SELECT "id",
                "roleId",
                "type",
                "categoryId",
                "pollId"
            FROM "poll_role"
        `);
    await queryRunner.query(`
            DROP TABLE "poll_role"
        `);
    await queryRunner.query(`
            ALTER TABLE "temporary_poll_role"
                RENAME TO "poll_role"
        `);
    await queryRunner.query(`
            CREATE UNIQUE INDEX "IDX_d62df873efb4582f4aa48dbe12" ON "poll_role" ("pollId", "roleId")
        `);
    await queryRunner.query(`
            CREATE UNIQUE INDEX "IDX_7f9f6fe949ee5383fb130c60a5" ON "poll_role" ("categoryId", "roleId")
        `);
  }

  async down(queryRunner) {
    await queryRunner.query(`
            DROP INDEX "IDX_7f9f6fe949ee5383fb130c60a5"
        `);
    await queryRunner.query(`
            DROP INDEX "IDX_d62df873efb4582f4aa48dbe12"
        `);
    await queryRunner.query(`
            ALTER TABLE "poll_role"
                RENAME TO "temporary_poll_role"
        `);
    await queryRunner.query(`
            CREATE TABLE "poll_role" (
                "id" integer PRIMARY KEY AUTOINCREMENT NOT NULL,
                "roleId" text NOT NULL,
                "type" text NOT NULL,
                "categoryId" integer,
                "pollId" integer
            )
        `);
    await queryRunner.query(`
            INSERT INTO "poll_role"("id", "roleId", "type", "categoryId", "pollId")
            SELECT "id",
                "roleId",
                "type",
                "categoryId",
                "pollId"
            FROM "temporary_poll_role"
        `);
    await queryRunner.query(`
            DROP TABLE "temporary_poll_role"
        `);
    await queryRunner.query(`
            CREATE UNIQUE INDEX "IDX_7f9f6fe949ee5383fb130c60a5" ON "poll_role" ("categoryId", "roleId")
        `);
    await queryRunner.query(`
            CREATE UNIQUE INDEX "IDX_d62df873efb4582f4aa48dbe12" ON "poll_role" ("pollId", "roleId")
        `);
    await queryRunner.query(`
            ALTER TABLE "vote"
                RENAME TO "temporary_vote"
        `);
    await queryRunner.query(`
            CREATE TABLE "vote" (
                "optionId" integer NOT NULL,
                "userId" bigint NOT NULL,
                "pollId" integer,
                PRIMARY KEY ("optionId", "userId")
            )
        `);
    await queryRunner.query(`
            INSERT INTO "vote"("optionId", "userId", "pollId")
            SELECT "optionId",
                "userId",
                "pollId"
            FROM "temporary_vote"
        `);
    await queryRunner.query(`
            DROP TABLE "temporary_vote"
        `);
    await queryRunner.query(`
            ALTER TABLE "poll_option"
                RENAME TO "temporary_poll_option"
        `);
    await queryRunner.query(`
            CREATE TABLE "poll_option" (
                "id" integer PRIMARY KEY AUTOINCREMENT NOT NULL,
                "name" text NOT NULL,
                "pollId" integer
            )
        `);
    await queryRunner.query(`
            INSERT INTO "poll_option"("id", "name", "pollId")
            SELECT "id",
                "name",
                "pollId"
            FROM "temporary_poll_option"
        `);
    await queryRunner.query(`
            DROP TABLE "temporary_poll_option"
        `);
    await queryRunner.query(`
            DROP INDEX "IDX_8649558b66d5659d710b2a441b"
        `);
    await queryRunner.query(`
            DROP INDEX "IDX_80709744068ae7f7a3ddd9b689"
        `);
    await queryRunner.query(`
            ALTER TABLE "poll"
                RENAME TO "temporary_poll"
        `);
    await queryRunner.query(`
            CREATE TABLE "poll" (
                "id" integer PRIMARY KEY AUTOINCREMENT NOT NULL,
                "guildId" bigint NOT NULL,
                "name" text NOT NULL,
                "channelId" bigint NOT NULL,
                "messageId" bigint,
                "categoryId" integer
            )
        `);
    await queryRunner.query(`
            INSERT INTO "poll"(
                    "id",
                    "guildId",
                    "name",
                    "channelId",
                    "messageId",
                    "categoryId"
                )
            SELECT "id",
                "guildId",
                "name",
                "channelId",
                "messageId",
                "categoryId"
            FROM "temporary_poll"
        `);
    await queryRunner.query(`
            DROP TABLE "temporary_poll"
        `);
    await queryRunner.query(`
            CREATE INDEX "IDX_8649558b66d5659d710b2a441b" ON "poll" ("guildId", "id")
        `);
    await queryRunner.query(`
            CREATE UNIQUE INDEX "IDX_80709744068ae7f7a3ddd9b689" ON "poll" ("messageId")
        `);
    await queryRunner.query(`
            DROP INDEX "IDX_7f9f6fe949ee5383fb130c60a5"
        `);
    await queryRunner.query(`
            DROP INDEX "IDX_d62df873efb4582f4aa48dbe12"
        `);
    await queryRunner.query(`
            DROP TABLE "poll_role"
        `);
    await queryRunner.query(`
            DROP INDEX "IDX_dd5d702fa30a021365cf68d938"
        `);
    await queryRunner.query(`
            DROP TABLE "poll_category"
        `);
    await queryRunner.query(`
            DROP TABLE "vote"
        `);
    await queryRunner.query(`
            DROP TABLE "poll_option"
        `);
    await queryRunner.query(`
            DROP INDEX "IDX_8649558b66d5659d710b2a441b"
        `);
    await queryRunner.query(`
            DROP INDEX "IDX_80709744068ae7f7a3ddd9b689"
        `);
    await queryRunner.query(`
            DROP TABLE "poll"
        `);
  }
}
