import VoterDataSource from "~/db/index.js";
import log from "~/log.js";

import { Poll, PollOption, Vote } from "./db/entities/poll.js";

export default async function start() {
  log.info("Initializing database");
  await VoterDataSource.initialize();
  await VoterDataSource.runMigrations();

  // add your logic below this line
  const poll = new Poll({
    name: "Hi",
    guildId: "124718941",
    channelId: "124718942",
  });
  await poll.save();

  const opt1 = await new PollOption({
    name: "Hi 1",
    poll,
  }).save();

  await new Vote({ userId: "1", poll, option: opt1 }).save();
  await new Vote({ userId: "2", poll, option: opt1 }).save();
  await new Vote({ userId: "3", poll, option: opt1 }).save();

  const opt2 = await new PollOption({
    name: "Hi 2",
    poll,
  }).save();

  await new Vote({ userId: "4", poll, option: opt2 }).save();
  await new Vote({ userId: "5", poll, option: opt2 }).save();
  await new Vote({ userId: "6", poll, option: opt2 }).save();
  await new Vote({ userId: "7", poll, option: opt2 }).save();

  const opt3 = await new PollOption({
    name: "Hi 1",
    poll,
  }).save();

  await new Vote({ userId: "8", poll, option: opt3 }).save();
  await new Vote({ userId: "9", poll, option: opt3 }).save();
}
